DDSD12 ;************************************************
 ;*						*
 ;*     	      DDSD/CMD  Version 1.2		*
 ;*						*
 ;*             For  TRS-80 Model I              *
 ;*						*
 ;*	   ADR for NEWDOS-80/Version 2		*
 ;*						*
 ;*	 	        by			*
 ;*						*
 ;*		 Allan J. Domuret		*
 ;*						*
 ;*		    May, 1982			*
 ;*						*
 ;************************************************
 ;
 ;
 SELECT	EQU	4773H
 RESTOR	EQU	4745H
 HIMEM	EQU	4049H
 SYSMEM	EQU	43A9H		;SYSTEM HIMEM for CLEAR
 GETDIR	EQU	48FDH
 DCTPNT	EQU	4399H		;Current drive DCT table
 DOSDIR	EQU	490FH		;RTN DOS after GETDIR dun
 DOSCOD	EQU	4369H		;Used by DOS for rfrence
 FMTCOD	EQU	5997H		;Used by FMT for rfrence
 DCT07	EQU	4311H		;DCT +07>bit 0 => DD/SD
 CRNTDR	EQU	4308H		;Current drive
 INITDI	EQU	48FAH		;Initialize and GETDIR
 PDRIVES	EQU	4371H		;Start PDRIVE table
 DRVCNT	EQU	439FH		;#Drives in system
 PATCH1	EQU	473CH		;DOS patch at 473CH
 PATCH2	EQU	490CH		;DOS patch at 439FH
 USEDCT	EQU	430AH		;Active DCT, used by DOS
 ;
 ;
 ;///////////////////////////////////////////////////
 ;
 	ORG	5200H
 ;
 ;
 START	LD	HL,MATH		;Math patch
 	LD	DE,4080H
 	LD	BC,0EH
 	DI
 	LDIR
 ;
 	PUSH	IY
 	LD	IY,DR0DD	;ADR Buffer
 ;
 	LD	HL,PDRIVES	;Move DOS PDRIVE codes
 	LD	DE,DR0DD
 	LD	BC,0028H	;40 BYTES = 4 DRIVES
 	PUSH	HL		; to DDSD loc
 	PUSH	BC
 	LDIR			;DD block
 	POP	BC
 	POP	HL
 	LDIR			;SD block
 ;
 ;If original PDRIVE was for SD, convert SD parameters
 ; to DD. SD track count is multiplied by 1.8 to get
 ; number of lumps as required by N82.
 ;
 	LD	A,(DRVCNT)	;OFFSET Drives in system
 	LD	B,A		;Set counter
 MAKDBL	PUSH	BC
 	BIT	0,(IY+07)	;Ck if already DD
 	JR	NZ,SKIP		;Already DD if NZ
 	LD	H,00
 	LD	L,(IY+03)	;TRUE TRACK COUNT
 	LD	DE,0008		;MULT BY 8/10 DECIMAL
 	CALL	0BF2H		;MULT IN ROM
 	PUSH	HL
 	POP	DE		;HL TO DE
 	LD	HL,000AH	;DIVIDE BY 10 DECIMAL
 	CALL	2490H		;DIVIDE IN ROM
 	CALL	0A8AH		;CONVERT (CINT)
 	XOR	A
 	LD	A,L
 	ADD	A,(IY+03)
 	LD	(IY+01),A	;OFFSET LUMPS
 ;
 	SET	4,(IY+02)	;Make DD
 	RES	2,(IY+02)	;Undo SD
 	LD	(IY+04),12H	;12H SECTORS/TRK
 	SET	0,(IY+07)	;Set DD code
 ;
 SKIP	POP	BC
 	LD	DE,000AH
 	ADD	IY,DE		;Point to next block
 	DJNZ	MAKDBL
 ;
 ;Next routine makes DD into SD
 ;
 	LD	IY,DR0SD
 	LD	A,(DRVCNT)	;Drives in system
 	LD	B,A		;Set counter
 	LD	DE,000AH	;Pointer bumper
 MAKSGL	BIT	0,(IY+07)
 	JR	Z,SKPSGL	;Skip if already SD
 	LD	A,(IY+03)	;TRUE TRACKS
 	LD	(IY+01),A	;SAME WHEN SD
 	LD	(IY+04),0AH	;0AH SECTORS/TRK
 	SET	2,(IY+02)	;Set SD
 	RES	4,(IY+02)	;Undo DD
 	RES	6,(IY+02)	;Ditto
 	RES	0,(IY+07)	;Set SD code
 	RES	1,(IY+07)	;No flip trk zero in SD
 ;
 ;Assume DDGA=2 for SD only
 ;
 	LD	(IY+09),02	;2 for DDGA=2, SD only
 SKPSGL	ADD	IY,DE		;Bump pointer
 	DJNZ	MAKSGL
 ;
 ;Apply relocate patches
 ;
 	POP	IY
 PATCHB	LD	DE,(HIMEM)
 	LD	HL,HI
 	LD	BC,HI-OFFSET+01
 	LDDR
 	LD	(HIMEM),DE
 	LD	(SYSMEM),DE	;SYSTEM HIMEM
 	INC	DE
 	PUSH	DE		;Save
 	INC	DE
 	LD	A,0C3H		;Insert DOS patch
 	LD	(PATCH2),A
 	LD	(PATCH2+01),DE
 	POP	DE		;Used by REPLAC routine
 ;
 ;Insert relocate values
 ;
 	LD	HL,0008H
 	CALL	REPLAC
 	LD	HL,0036H
 	CALL	REPLAC
 	LD	HL,004AH
 	CALL	REPLAC
 	LD	HL,0058H
 	CALL	REPLAC
 	LD	HL,005DH
 	CALL	REPLAC
 	JR	PATCHA
 ;
 REPLAC	ADD	HL,DE
 	LD	C,(HL)
 	INC	HL
 	LD	B,(HL)
 	DEC	HL
 	PUSH	DE
 	EX	DE,HL
 	ADD	HL,BC
 	EX	DE,HL
 	LD	(HL),E
 	INC	HL
 	LD	(HL),D
 	POP	DE
 	RET
 ;
 ;End of relocate
 ;
 PATCHA	LD	HL,(HIMEM)
 	INC	HL
 	LD	DE,DDSD-OFFSET
 	ADD	HL,DE
 	LD	(PATCH1+01),HL	;Patch DOS; DE=>DCT07
 	LD	A,0C2H		;Jp Code
 	LD	(PATCH1),A
 	EI
 ;
 DSPLY	CALL	01C9H		;cls
 	LD	HL,3C40H	;Set cursor
 	LD	(4020H),HL
 	LD	HL,TEXT
 	CALL	4467H
 ;
 	JP	402DH
 ;
 ;
 TEXT	DEFM	'DDSD/CMD -- Double/Single Density -- Version 1.2 -- May 1982'
 	DEFB	0AH
 	DEFM	'Automatic PDRIVE Utility For Use With NEWDOS-80, Version 2 (c)'
 	DEFW	0A0AH
 	DEFM	'  Distributed by: The Alternate Source, Lansing, Michigan.'
 	DEFB	0AH
 	DEFM	'                '	;18 blanks
 	DEFM	'Written by Allan J. Domuret'
 	DEFW	0A0AH
 ;
 	DEFM	'                           '	;28x20H
 	DEFM	'Model I'
 	DEFB	0AH
 	DEFM	'     '			;5 blanks
 	DEFM	'      Automatic Density Recognition Enabled '
 	DEFB	0AH
 	DEFB	0DH
 ;
 ;Z80 code required by ROM for * and /
 ;
 MATH	DEFW	00D6H
 	DEFW	7C6FH
 	DEFW	00DEH
 	DEFB	67H
 	DEFW	0DE78H
 	DEFW	4700H
 	DEFW	003EH
 	DEFB	0C9H
 ;
 ;	ORG	0001H
 ;
 ;/////////////////////////////////////////////////
 ;
 ;Next is the actual DDSD working code which is to
 ; be automatically relocated to HIMEM and protected.
 ;
 ;
 OFFSET	EQU	$
 ;
 ;Catch DIR error here.
 ;
 SWITCH	DB	0FBH		;Off-On switch
 ;
 DODIR	CALL	GETDIR		;DOS Call
 	JR	Z,GODOS		;Back to DOS
 ;
 ;If FORMAT working, do nothing. Go to DOS.
 ;
 	PUSH	AF
 	CALL	FMTCK-OFFSET	;Check if FORMAT up
 	JR	Z,RTNDOS	;Skip ADR if FMT
 	POP	AF
 ;
 ;Flip Track zero to try TI=CK
 ;
 FLIP	PUSH	IY
 	LD	IY,(DCTPNT)	;Current drive DCT
 	BIT	0,(IY+07)	;DD if set
 	JR	Z,NOFLIP		;No flip if SD
 	LD	A,(IY+02)	;Flip bit 6
 	XOR	40H
 	LD	(IY+02),A
 	LD	A,(IY+07)	;Flip bit 1
 	XOR	02H
 	LD	(IY+07),A
 NOFLIP	POP	IY
 ;
 	CALL	INITDI		;Try DIR again
 GODOS	JP	DOSDIR		;Back to DOS
 ;
 RTNDOS	POP	AF
 	JP	DOSDIR
 ;
 ;Subroutine to check if FORMAT active,
 ; but first check for On-Off switch from DSET/CMD.
 ;
 FMTCK	LD	A,(SWITCH-OFFSET)
 	OR	A
 	RET	Z
 ;
 	LD	A,(DOSCOD)	;Check for FORMAT
 	CP	58H
 	RET	NZ
 	LD	A,(FMTCOD)	;Double Check for FMT
 	AND	0F9H		;Check bits 1 & 2
 	RET			;Will be zero if FMT up
 ;
 ;Intercept bad sector read; Flip-flop SD vs DD
 ;
 DDSD	PUSH	BC
 	PUSH	DE
 	PUSH	HL
 ;
 	CALL	FMTCK-OFFSET	;See if FORMAT is up
 	JR	Z,BYPASS	;Skip if FORMAT
 ;
 NOFMT	LD	A,(DCT07)	;DCT + 07 - Ck DD or SD
 	OR	0FEH
 	XOR	01H		;Change Density
 	BIT	0,A
 	LD	HL,DR0DD-OFFSET		;DD DCT pointer
 	JR	NZ,ADR
 	LD	HL,DR0SD-OFFSET		;SD DCT pointer
 ;
 ADR	LD	(37ECH),A
 	LD	A,0D0H
 	LD	(37ECH),A
 ;
 ;Adjust DDSD DCT pointer for current drive
 ;
 	LD	A,(CRNTDR)	;Current drive
 	LD	C,A
 	RLCA
 	RLCA
 	ADD	A,C
 	ADD	A,A
 	LD	E,A
 	LD	D,00
 	ADD	HL,DE
 ;
 ;HL now points to current DDSD DCT block.
 ; Move DDSD DCT to NEWDOS/80 PDRIVE table in RAM
 ;
 	PUSH	HL
 	LD	DE,(DCTPNT)	;Dest. for block
 	LD	BC,000AH	;Move 10 bytes
 	DI
 	LDIR			;Move two places
 	POP	HL
 	LD	DE,USEDCT
 	LD	BC,0008H	;Move 8 bytes
 	LDIR
 ;
 	CALL	RESTOR		;Head to track zero
 ;
 ;Check for ZAP and DIRCHECK, patch if needed.
 ;
 ZAP	LD	A,(5EF9H)	;IF 4436H, ASSUME ZAP
 	CP	36H
 	JR	NZ,DIRCK
 	LD	A,(5EFAH)
 	CP	44H
 	JR	NZ,DIRCK
 	LD	A,(430EH)	;SPT
 	LD	(549BH),A	;Patch ZAP
 	JR	BYPASS
 ;
 ;DIRCHECK working?
 ;
 DIRCK	LD	A,(5827H)
 	CP	36H
 	JR	NZ,BYPASS
 	LD	A,(5828H)
 	CP	44H
 	JR	NZ,BYPASS
 	LD	HL,(DCTPNT)	;Current DCT pointer
 	LD	DE,5260H	;DCT location for DRCK
 	LD	BC,0008H
 	LDIR
 ;
 BYPASS	EI
 	POP	HL
 	POP	DE
 	POP	BC
 	JP	4660H
 ;
 	NOP
 SRCEND	DEFB	0ADH		;Used by DSET/CMD
 ;
 ;40 spaces required for DD PDRIVE code table values.
 ;
 DR0DD	DEFM	'                    '	;20 Bytes
 	DEFM	'                    '	;Ditto
 ;
 ;40 spaces required for SD PDRIVE code table values.
 ;
 DR0SD	DEFM	'                    '	;20 Bytes
 	DEFM	'                    '	;Ditto
 ;
 HI	DEFB	0ADH
 ;
 	END	START
	DEFM	'                    '	;Ditto
 ;
 ;40 spaces require