DSET12 ;************************************************
 ;*						*
 ;*     	      DSET/CMD  Version 1.2		*
 ;*						*
 ;*             For  TRS-80 Model I              *
 ;*						*
 ;*	   ADR for NEWDOS-80/Version 2		*
 ;*						*
 ;*	 	        by			*
 ;*						*
 ;*		 Allan J. Domuret		*
 ;*						*
 ;*		    May, 1982			*
 ;*						*
 ;************************************************
 ;
 ;This version is modified in that it can be called
 ; from BASIC as a "CMD" file. Additionally, it can
 ; be used to turn DDSD/CMD On or Off, or Purge it.
 ;
 ;
 SYSMEM	EQU	43A9H
 HIMEM	EQU	4049H
 ;
 ;
 	ORG	5200H
 ;
 ;Check for DDSD/CMD active.
 ;
 START	LD	HL,(473DH)	;DDSD Patch Adrs
 	LD	DE,4742H	;DE = (473DH)
 	XOR	A
 	SBC	HL,DE
 	JP	Z,ABORT		;No ADR installed
 ;
 	CALL	01C9H
 	LD	A,(439FH)	;# Drives in system
 	LD	C,A		;Save
 ;
 ;Get input: DSET 0D,1S,2D,3D is rqd format.
 ; Four drives max.
 ;
 INPUT	LD	B,00		;Counter
 	LD	HL,4319H	;Input buff pointer
 	LD	A,(HL)		;HL=> DOS input buff
 	CP	0DH
 	JP	Z,SPRINT	;Screen print DCT
 	LD	IY,STORE	;Storage Buff
 	DEC	HL
 INLOOP	INC	HL
 	LD	A,(HL)
 	CP	20H
 	JR	Z,INCHL
 	CP	','		;Comma OK too
 	JR	Z,INCHL
 	CP	0DH		;Done
 ;
 EOL	JP	Z,MKCHNG	;Done, so make changes
 	JR	INLOOP		;Keep looking for eol
 INCHL	INC	HL
 	LD	A,(HL)		;Drv 0 - 3 rqd 1st
 	CALL	INPSAV		;Store inputs
 ;
 ;Return fm INPSAV.
 ;
 	INC	B		;# Drives commanded
 	LD	A,(439FH)	;# Drives in system
 	CP	B		;Four drive max
 	JP	Z,MKCHNG	;No more drives
 	JR	INLOOP		;Look again
 ;
 ;IY points to storage buff; HL points to input buff.
 ;
 INPSAV	CP	'O'
 	JP	Z,OFFON		;Ck for off or on
 	CP	'D'		;Ck for Delete
 	JP	Z,DELETE
 ;
 	CP	34H
 	JP	NC,ERR2		;ERR2 = Bad code
 	CP	30H
 	JP	C,ERR2		;Ditto
 	SUB	30H		;Make hex
 	LD	(IY+00),A	;Save drive 0
 ;
 ;Next charcter must be S or D (UC or LC) with
 ; no separator.
 ;
 	INC	HL		;Must be S or D
 	INC	IY
 	LD	A,(HL)
 	RES	5,A		;Make upper case
 	CP	'S'		;SD Ck
 	JR	Z,INPTOK
 	CP	'D'		;DD Ck
 	JR	Z,INPTOK
 	POP	AF		;Dump RET
 	JP	ERR2		;ERR2 = Bad entry
 ;
 ;HL gets bumped in parameter input scan.
 ;
 INPTOK	LD	(IY),A		;Save Density
 	INC	IY
 	RET
 ;
 ;B contains count for number of drive DCTs to change.
 ;STORE buff contains parms in drv/dnsty format.
 ;
 MKCHNG	LD	A,B		;Save # inputs
 	LD	(INPUTS),A
 	OR	A
 	JR	Z,SPRINT	;If Z, no changes
 	PUSH	BC		;B = drive count input
 	LD	HL,(473DH)	;HL => DDSD adrs
 	LD	BC,0120H	;Byte limit for srch
 	LD	A,0ADH		;Search value
 LKAGN	CPIR
 	PUSH	HL
 	DEC	HL
 	DEC	HL		;Backup 2 bytes
 	LD	A,(HL)
 	OR	A		;Should be zero
 	POP	HL		;HL=> DDSD DCT
 	JR	NZ,LKAGN	;Not found.
 ;If BC=00, search failed. Abort.
 ;
 	LD	A,B		;Ck if BC=00
 	CP	C
 	POP	BC		;B = Drive count input
 	JP	Z,ABORT
 ;
 ;HL=>DDSD/CMD DCT, DD block.
 ;B = Number of drives affected (DCTs to change)
 ;Use C for drive number (0 - 3) affected
 ;
 	LD	IY,STORE	;Setup buff pointer
 	PUSH	HL		;HL=> DDSD DCT
 MOVES	LD	A,(IY+00)	;Drive 0 - 3
 	LD	C,A		;Keep track in C reg
 	LD	A,(IY+01)	;S or D ?
 	CP	'D'		;If D, HL point is OK
 	POP	HL
 	PUSH	HL		;Get original pointer
 	CALL	NZ,MKSGL	;Adj HL to SD block
 	LD	DE,4371H	;Dest for drive 0
 	LD	A,C		;Drive 0 - 3 Chk
 	OR	A		;Drive 0?
 	JR	Z,NOADJ		;No Adjustment
 BLKADJ	PUSH	BC
 	LD	BC,000AH	;Increment by 10
 	ADD	HL,BC		;Bump HL by 10
 	PUSH	HL		;Save
 	PUSH	DE
 	POP	HL
 	ADD	HL,BC		;Bump DE by 10
 	PUSH	HL
 	POP	DE		;Restore DE
 	POP	HL		;Restore HL
 	POP	BC
 	DEC	C
 	JR	NZ,BLKADJ	;Bump pointers by 10
 ;
 NOADJ	PUSH	BC
 	LD	BC,000AH	;Move 10 bytes
 	INC	IY		;Bump for next move
 	INC	IY
 	LD	(SRC+01),HL	;Set up block move
 	LD	(DEST+01),DE
 	LD	(COUNT+01),BC
 	CALL	BLKMOV		;Move 10 bytes to DCT
 	POP	BC
 	DJNZ	MOVES		;Rpt for # drive chngs
 ;
 ;
 ;Display current DCT settings
 ;
 ;
 ;B gets number of inputs (drives changed) to count.
 ;
 SPRINT	LD	IX,DENMSG	;Msg pointer
 	LD	IY,4371H	;DCT pointer
 	LD	A,(439FH)	;Report on all drives
 	LD	B,A
 	CP	01		;One drive?
 	JR	Z,PATCH
 AGN	BIT	0,(IY+07)
 	LD	A,'S'
 	JR	Z,LOADIT
 	LD	A,'D'
 LOADIT	LD	(IX+0BH),A
 	LD	DE,000AH
 	ADD	IY,DE
 	LD	DE,000CH
 	ADD	IX,DE
 	INC	IX
 	DJNZ	AGN
 	JP	DUN
 PATCH	LD	(IX+0DH),03
 	JP	DUN
 ;
 ;
 ;***************************************************
 ;
 ;If HIMEM corresponds to DDSD/CMD, adjust HIMEM
 ; and SYSMEM when DDSD/CMD is deleted.
 ;Else, leave HIMEM and SYSMEM intact and turn
 ; DDSD/CMD off.
 ;
 OFFON	INC	HL
 	LD	A,(HL)
 	CP	'F'		;Off
 	JR	Z,TRNOFF
 	CP	'N'		;On
 	JR	Z,TRNON
 	POP	AF		;Purge RET
 	JP	ERR2
 ;
 ;
 DELETE	LD	HL,(490DH)	;Top of DDSD/CMD
 	LD	DE,(HIMEM)
 	INC	DE
 	INC	DE
 	PUSH	HL
 	XOR	A
 	SBC	HL,DE		;Test if equal
 	POP	HL		;Start search value
 	JR	NZ,RESTOR	;Restore DOS codes
 ;
 GETMEM	LD	BC,0250H
 LOOP	LD	A,0ADH
 	PUSH	BC
 	CPIR
 	POP	BC
 	JP	NZ,NODDSD	;No DDSD installed
 	DJNZ	LOOP
 ;
 	DEC	HL
 	LD	(HIMEM),HL
 	LD	(SYSMEM),HL
 ;
 ;Restore DOS codes
 ;
 RESTOR	LD	A,0C4H
 	LD	(473CH),A
 	LD	HL,4742H
 	LD	(473DH),HL
 	LD	A,0CDH
 	LD	(490CH),A
 	LD	HL,48FDH
 	LD	(490DH),HL
 	LD	A,0FCH		;Msg for Delete
 	LD	(MSGSTR),A
 	POP	AF		;Purge RET adrs
 	JP	SPRINT
 ;
 ;Turn off only. Keep available to reactivate
 ;
 TRNOFF	LD	HL,(490DH)	;Base of DDSD
 	DEC	HL		;Point to switch
 	XOR	A		;Zero is Off code
 	LD	(HL),A		;Turn off
 	LD	A,0FBH		;Msg code
 	LD	(MSGSTR),A
 	POP	AF		;Purge RET adrs
 	JP	SPRINT
 ;
 ;Turn DDSD/CMD back on
 ;
 TRNON	LD	HL,(490DH)	;Base of DDSD
 	DEC	HL
 	LD	A,0FBH		;Non-zero is On code
 	LD	(HL),A		;Turn on
 	LD	A,0FAH		;Msg for ON
 	LD	(MSGSTR),A
 	POP	AF		;Purge RET adrs
 	JP	SPRINT
 ;
 ;Subroutines
 ;
 ;
 DUN	LD	(IX),03
 	LD	HL,DENMSG	;Display DCT settings
 DSP	CALL	DSPLY
 	LD	HL,MSGON
 	LD	A,(MSGSTR)
 	CP	0FAH
 	JR	Z,MSG
 	LD	HL,MSGOFF
 	CP	0FBH
 	JR	Z,MSG
 	LD	HL,MSGDEL
 	CP	0FCH
 	JR	NZ,OUT
 ;
 MSG	LD	A,0DH
 	CALL	0033H
 	CALL	4467H
 ;
 OUT	EI
 	JP	402DH
 ;
 DSPLY	PUSH	HL
 	CALL	01C9H
 	LD	HL,3C80H
 	LD	(4020H),HL
 	POP	HL
 	CALL	4467H
 	RET
 ;
 ;
 ;Make HL point to SD DCT block
 ;
 MKSGL	PUSH	DE
 	LD	DE,0028H
 	ADD	HL,DE		;HL Points to DR0SD
 	POP	DE
 	RET
 ;
 ;Move DCT from DDSD to DOS DCT area
 ;
 BLKMOV	DI
 SRC	LD	HL,0000
 DEST	LD	DE,0000
 COUNT	LD	BC,0000
 	LDIR
 	EI
 	RET
 ;
 ;Parameter input buffer
 ;
 STORE	DEFM	'                    '	;20 blanks
 ;
 INPUTS	DEFB	00		;Store # bytes input
 ;
 FRST	DEFB	00		;Set 0FFH for next pass
 ;
 ;Messages and errors
 ;
 ABORT	LD	HL,NODDSD
 	JR	DSP
 ;
 ERR2	LD	HL,BADINP
 	JR	DSP
 ;
 MSGOFF	DEFM	'DDSD Turned Off, But Protected In RAM.'
 	DEFB	0DH
 ;
 MSGON	DEFM	'DDSD Is On and Ready.'
 	DEFB	0DH
 ;
 MSGDEL	DEFM	'DDSD Purged.  All DOS instruction'
 	DEFB	0AH
 	DEFM	'codes are returned to normal.'
 	DEFB	0DH
 ;
 ;
 NODDSD	DEFM	'Error: DDSD Not Installed.'
 	DEFW	0DH
 ;
 BADINP	DEFM	'Error: Bad Input -- '
 	DEFW	0A0AH
 	DEFM	'Input format is:  DSET 0D,1S,2D,3S <Enter>'
 	DEFW	0A0AH
 	DEFM	'Drive numbers are specified as 0 - 3'
 	DEFB	0AH
 	DEFM	'The S or D specifies Single or Double Density'
 	DEFW	0A0AH
 	DEFM	'Also allowed:  <DSET OFF>, <DSET ON>, or DSET <DELETE>'
 	DEFB	0DH
 ;
 ;
 DENMSG	DEFM	'Drive 0 =>  '
 	DEFB	0AH
 	DEFM	'Drive 1 =>  '
 	DEFB	0AH
 	DEFM	'Drive 2 =>  '
 	DEFB	0AH
 	DEFM	'Drive 3 =>  '
 	DEFW	0AH,0DH
 ;
 	NOP
 ;
 MSGSTR	DEFB	00
 ;
 ;
 	END	START
NMSG	DEFM	'Drive 0 =>  '
 	DEFB	0AH
 	DEFM	'Drive 1 =>  '
 	DEFB	0AH
 	DEFM	'Drive 2 =>  '
 	DEFB	0AH
 	DEFM	'Drive 3 =>  '
 	DEFW	0A